<?php

namespace App\Http\Resources\API;

use Illuminate\Http\Resources\Json\JsonResource;

class App extends JsonResource
{
    /**
     * Transform the resource into an array.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return array
     */
    public function toArray($request)
    {
        return [
            'id' => (int)$this->id,
            'name' => $this->name,
            'description' => $this->description,
            'directUrl' => $this->direct_url,
            'url' => $this->url,
            'iconURL' => $this->iconURL,
            'properties' => [
                'testingWarning' => (bool)$this->testing_warning,
                #'autoAccept' => (bool)$this->auto_accept,
                'untrustedWarning' => (bool)$this->untrusted_warning,
                'showOnWebpage' => (bool)$this->show_on_webpage,
                'stopAutoRedirect' => (bool)$this->stop_auto_redirect,
                'hideInAppList' => (bool)$this->hidden_in_app_list,
                'userCantRemoveApp' => (bool)$this->user_cant_remove_app
            ],
            'access' => [
                'oAuth' => (bool)$this->access_oAuth,
                'api' => (bool)$this->access_api,
                'update_apps' => (bool)$this->access_update_apps,
                'update_profile' => (bool)$this->access_update_profile,
                'update_access' => (bool)$this->access_update_access,
                'read_access' => (bool)$this->access_read_access,
                'read_apps' => (bool)$this->access_read_apps,
                'read_profile' => (bool)$this->access_read_profile,
            ]
        ];
    }
}
