<?php

namespace App\Http\Resources\API;

use Carbon\Carbon;
use Illuminate\Http\Resources\Json\JsonResource;

class User extends JsonResource
{
    /**
     * Transform the resource into an array.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return array
     */
    public function toArray($request)
    {
        $created_at = Carbon::parse($this->created_at);
        $updated_at = Carbon::parse($this->updated_at);
        return [
            'id' => (int)$this->id,
            'username' => $this->username,
            'created_at' => $created_at->format("Y-m-d H:i:s e"),
            'updated_at' => $updated_at->format("Y-m-d H:i:s e"),
            'primaryMail' => $this->getMail(),
            'status' => $this->status,
            'inviteCode' => $this->inviteCode,
            'developer' => (bool)$this->developer,
            'admin' => (bool)$this->admin
        ];
    }
}
