<?php

use Illuminate\Support\Facades\Schema;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Database\Migrations\Migration;

class AppIconUrl extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::table('apps', function (Blueprint $table) {
            $table->removeColumn("icon");
            $table->string("iconURL", 500)->nullable()->comment("Public link to icon");
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::table('apps', function (Blueprint $table) {
            $table->binary("icon")->nullable()->default(null)->comment("200x200 Image as Icon");
            $table->removeColumn("iconURL");
        });

        //
    }
}
